/*
	$Id: RecipeLoader.java 97 2006-03-01 13:11:45Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import java.awt.GridLayout;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JProgressBar;

/**
   쥷Ԥɤ륵Хȡ
*/
public class RecipeLoader extends Servant {

    /** ƥȥեͥ */
    private Funnel funnel;

    /** åɤȯ㳰Τꥹ */
    private ExceptionListener listener;

    /** ץ饤Υ꡼ */
    private ReplyReader<RecipeReply> replyReader;

    /** Funnelؤνϥȥ꡼ */
    private DataOutputStream out;

    /**
       쥷ԤΥޤ

       @param parent 쥷ԤΥɽֿĽפο
       Ȥʤե졼
       @param receiver 쥷
       @param out ϥȥ꡼
       @param funnel ƥȥեͥ
       @param listener åɼ¹Իȯ㳰Τ뤿
       ꥹ
    */
    public RecipeLoader(final JFrame parent, final Receiver receiver,
			final DataOutputStream out, final Funnel funnel,
			final ExceptionListener listener) {
	super(parent, "Cancel");
	this.funnel = funnel;
	this.listener = listener;
	this.out = out;
	replyReader = new ReplyReader<RecipeReply>(receiver) {
	    protected RecipeReply getReply(byte[] data)
	    throws ProtocolException {
		return new RecipeReply(data);
	    }
	};
	setIndeterminate(true);
    }

    /**
       쥷Ԥƥեͥ򹹿ޤ
    */
    protected final void run() {
	try {
	    out.writeInt(1);
	    out.flush();
	} catch (IOException e) {
	    listener.exceptionCaught(e);
	    return;
	}
	try {
	    RecipeReply reply = replyReader.getReply();
	    funnel.setRecipe(reply.getRecipe());
	} catch (ProtocolException e) {
	    listener.exceptionCaught(e);
	    return;
	} catch (InterruptedException e) {
	}
    }
}
