/*
	$Id: OutputStream.h 103 2006-03-02 15:33:17Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

#ifndef IMPL_OUTPUTSTREAM_H
#define IMPL_OUTPUTSTREAM_H

#include <unistd.h>
#include "Object.h"

struct impl_OutputStream {
    union {
	struct impl_Object object;
    } super;
    ssize_t (*write)(struct impl_OutputStream *, const void *, size_t);
    int (*close)(struct impl_OutputStream *);
    int ancientStream;
};

void
impl_OutputStream_new(struct impl_OutputStream *,
		      ssize_t (*)(struct impl_OutputStream *,
				  const void *, size_t),
		      int (*)(struct impl_OutputStream *));

#endif /* !IMPL_OUTPUTSTREAM_H */
